//
//  ViewController.swift
//  AmpMediaAnalyticsSample
//
//  Created by David Cortes on 10/12/18.
//  Copyright © 2023 David Cortes. All rights reserved.
//

import UIKit
import AmpCore
import AmpMediaAnalytics

class ViewController: UIViewController {
    
    var ampPlayer:AmpPlayer!
    var ampMediaAnalytics:AmpMediaAnalyticsManager!
    
    let url = "http://multiplatform-f.akamaihd.net/i/multi/will/bunny/big_buck_bunny_,640x360_400,640x360_700,640x360_1000,950x540_1500,.f4v.csmil/master.m3u8"

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.ampPlayer = AmpPlayer(parentView: self.view)
        setupMA()
        self.ampPlayer.setLicense("AwHMtbro7sDv/9bpK9PFlUCFwKDMjbpXidQJ24TMwn3/stREOrOoWLGr4xAJoG3LrEi/2SldObMnwTgWJBY1VO46QXqt5i8vvG5eit5yJJo5GFj3wgV+pBO1X085kHccbDdvcD0rNRPwHdbdizmicw20M2ofBJi4/KOi0OjsNAJD7DINQ9sNJ+IMsJC0DBIabTm/4um1Qd4O67WTBwnOAM5WHcgS0dRpMrQG+qpyV8Q5HTmHDDmd2qQDlBu2nBRM4lw=")
        
        self.ampPlayer.registerObserver(self)
        self.ampPlayer.autoplay = true
        self.ampPlayer.play(url: url)
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        self.ampPlayer.stop()
        super.viewWillDisappear(animated)
    }
    
    func setupMA() {
        let analyticsUrl = "https://ma1019-r.analytics.edgekey.net/config/beacon-8566.xml"
        
        let customData = [
            "title": "AKaMTitle",
            "category": "AKamCategory",
            "playerId": "AKAM AVPlayer playerId",
            "device": "AKAM AVPlayer device",
            "show": "AKAM AVPlayer$show"
        ]
        
        self.ampMediaAnalytics = AmpMediaAnalyticsManager(  ampPlayer: self.ampPlayer, configurationUrl: analyticsUrl, dimensions: customData)
    }

}

extension ViewController: PlayerEventObserver {
    func onBufferingStateChanged(_ ampPlayer: AmpPlayer) {
        print("The buffering state changed to \(ampPlayer.bufferingState)")
    }
    
    func onPlaybackStateChanged(_ ampPlayer: AmpPlayer) {
        print("Playback state changed to \(ampPlayer.playbackState)")
    }
}

